function varargout = gui(varargin)
clc,
% GUI MATLAB code for gui.fig
%      GUI, by itself, creates a new GUI or raises the existing
%      singleton*.
%
%      H = GUI returns the handle to a new GUI or the handle to
%      the existing singleton*.
%
%      GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GUI.M with the given input arguments.
%
%      GUI('Property','Value',...) creates a new GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before gui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help gui

% Last Modified by GUIDE v2.5 29-Sep-2014 10:11:59

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @gui_OpeningFcn, ...
                   'gui_OutputFcn',  @gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

% End initialization code - DO NOT EDIT


% --- Executes just before gui is made visible.
function gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to gui (see VARARGIN)

% Choose default command line output for gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);
axes(handles.axes4);
imshow('upct.jpg');
movegui('center')



% UIWAIT makes gui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



% --- Executes on button press in button_sim.
function button_sim_Callback(hObject, eventdata, handles)
% hObject    handle to button_sim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%Pop Menu Configuration:

simulation;
set(handles.save_button,'Visible','On');
set(handles.button_AMF,'Visible','On');
axes(handles.plot1), cla;
plot(t/1e-6,s2,'k'),hold on;
plot(t/1e-6,s3,'b'), 
axis tight, grid on, xlabel 'Time [\mus]', ylabel 'v(t)'
legend ('s_t(t)', 's_r(t)')

padding='                    ';
set(handles.select_plot,'String',[['Transmitted & Recieved Signal (Time)'...
    ,padding(1:6)];['Transmitted & Recieved Signal (Freq)',padding(1:6)];...
    ['Matched Filter Transfer Function (Freq)',padding(1:3)]; ...
    ['Matched Filter Output (Time)',padding(1:14)];...
    ['Matched Filter Output (Freq)',padding(1:14)]])
if (mismatched_bool)
    set(handles.select_plot,'String',[get(handles.select_plot,'String')...
        ;['Mismatched Filter Output (Time)',padding(1:11)];...
        'Mismatched Filter Transfer Function (Freq)'])
end
set(handles.select_plot,'String',[get(handles.select_plot,'String')...
    ;['Detected Signal (Time)',padding(1:20)];...
    ['Detected Signal (Freq)',padding(1:20)];...
    ['Range Gates (Detection of target)',padding(1:9)]])
set(handles.select_plot,'Value',1);


% --- Executes on button press in button_load.
function button_load_Callback(hObject, eventdata, handles)
% hObject    handle to button_load (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.button_AMF,'Visible','Off')
config;
set(handles.button_sim,'Visible','On')



% --- Executes on selection change in select_plot.
function select_plot_Callback(hObject, eventdata, handles)
global f tau fs t s2 S2 S3 s3 R r prf Hf gates mismatched_bool r_detected ...
    R_DETECTED r_mis Hmis f0 Af
% hObject    handle to select_plot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns select_plot contents as cell array
%        contents{get(hObject,'Value')} returns selected item from select_plot
p=get(handles.select_plot,'Value');
axes(handles.plot1), cla;
switch p
    
   case 2
       
    plot(f/1e6,abs(fftshift(S2)),'k'), hold on
    plot(f/1e6,abs(fftshift(S3)),'b--'), title('Targets Signal');
    axis tight, grid on, xlabel 'Frequency [Mhz]', 
    legend ('|S_t(f)|', '|S_r(f)|'), 
       
   case 3
       
    plot(f/1e6,abs(fftshift(Hf)),'k'), 
    axis tight, grid on, xlabel 'Frequency [Mhz]',
    ylabel '|Hf(f)|', legend off
    
    
   case 4
       
    plot(t/1e-6,r,'k'), legend off
    axis tight, grid on, xlabel 'Time [\mus]',
    ylabel 'r(t)'
    
    
   case 5
        
    plot(f/1e6,abs(fftshift(R)),'k'),legend off
    axis tight, grid on, xlabel 'Frequency [Mhz]',
    ylabel '|R(f)|'
    
       
   case 6
       
       if (mismatched_bool)       

        plot(t/1e-6,r_mis,'k'), legend off
        axis tight, grid on, xlabel 'Time [\mus]',  
        ylabel 'rmis(t)'
        
       else 

        plot(t/1e-6,abs(r_detected),'k'), legend off;
        axis tight, grid on, xlabel 'Time [\mus]', ylabel 'r_d_e_t_e_c_t_e_d(t)'           
        
       end 
       
   case 7
       
       if (mismatched_bool) 

        plot(f/1e6,abs(Hmis),'k'),
        axis([(f0-Af)/1e6 (f0+2*Af)/1e6 0 max(abs(Hmis))]), grid on, xlabel 'Frequency [Mhz]',
        ylabel '|Hmis(f)|', legend off
        
       else 

        plot(f/1e6,abs(fftshift(R_DETECTED)),'k'),
        axis tight, grid on, xlabel 'Frequency [Mhz]',
        ylabel '|R_DETECTED(f)|', legend off
        
       end 

       
   case 8
       
       if (mismatched_bool) 
           
        plot(t/1e-6,abs(r_detected),'k'), legend off;
        axis tight, grid on, xlabel 'Time [\mus]', ylabel 'r_d_e_t_e_c_t_e_d(t)'
        
        
       else
           
        distance=(t(1:fs/prf)-tau)*3e8/2;
        plot(distance/1e3,max(r_detected(1:fs/prf))*gates(:,1:fs/prf)),hold on;
        plot(distance/1e3,abs(r_detected(1:fs/prf)),'k'), legend off
        axis tight, grid on, xlabel 'Distance [Km]', ylabel 'r_d_e_t_e_c_t_e_d(t)'
        
        
       end 
       


   case 9
       
    if  (mismatched_bool)          

        plot(f/1e6,abs(fftshift(R_DETECTED)),'k'),
        axis tight, grid on, xlabel 'Frequency [Mhz]',
        ylabel '|R_DETECTED(f)|', legend off
        
    else       

        distance=(t(1:fs/prf)-tau)*3e8/2;
        plot(distance/1e3,max(r_detected(1:fs/prf))*gates(:,1:fs/prf)),hold on;
        plot(distance/1e3,abs(r_detected(1:fs/prf)),'k'), legend off
        axis tight, grid on, xlabel 'Distance [Km]', ylabel 'r_d_e_t_e_c_t_e_d(t)'
        
    end

   case 10

        distance=(t(1:fs/prf)-tau)*3e8/2;
        plot(distance/1e3,max(r_detected(1:fs/prf))*gates(:,1:fs/prf)),hold on;
        plot(distance/1e3,abs(r_detected(1:fs/prf)),'k'), legend off
        axis tight, grid on, xlabel 'Distance [Km]', ylabel 'r_d_e_t_e_c_t_e_d(t)'    
        
   otherwise
    
    plot(t/1e6,s2,'k'),
    hold on;
    plot(t/1e6,s3,'b--'),
    axis tight, grid on, xlabel 'Time (\mus)', ylabel 's(t)'  
    legend ('s_t(t)', 's_r(t)')
end


% --- Executes during object creation, after setting all properties.
function select_plot_CreateFcn(hObject, eventdata, handles)
% hObject    handle to select_plot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in button_AMF.
function button_AMF_Callback(hObject, eventdata, handles)
% hObject    handle to button_AMF (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
AF_calc;


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
delete(hObject);


% --------------------------------------------------------------------
function Untitled_1_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in save_button.
function save_button_Callback(hObject, eventdata, handles)
% hObject    handle to save_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global f tau fs t s2 S2 S3 s3 R r prf Hf gates mismatched_bool r_detected ...
    R_DETECTED r_mis Hmis f0 Af
name=['plot',num2str(get(handles.select_plot,'Value')),'_' ...
    ,num2str(round(now*1e4)),'.jpeg'];
name=strrep(name,' ','_');
width = 7;    
height = 5;    
alw = 0.1;    
fsz = 11;      
lw = 1;            
h=figure(22);
pos = get(gcf, 'Position');
set(gcf, 'Position', [pos(1) pos(2) width*100, height*100]); %<- Set size
set(gca, 'FontSize', fsz, 'LineWidth', alw);


p=get(handles.select_plot,'Value');
switch p
    
   case 2
       
    plot(f/1e6,abs(fftshift(S2)),'k','LineWidth',lw), hold on
    plot(f/1e6,abs(fftshift(S3)),'b--','LineWidth',lw), 
    axis tight, grid on, xlabel 'Frequency [Mhz]', 
    legend ('|S_t(f)|', '|S_r(f)|'), 
       
   case 3
       

    plot(f/1e6,abs(fftshift(Hf)),'k','LineWidth',lw), 
    axis tight, grid on, xlabel 'Frequency [Mhz]',
    ylabel '|Hf(f)|', legend off
    
    
   case 4
       

    plot(t/1e-6,r,'k','LineWidth',lw), legend off
    axis tight, grid on, xlabel 'Time [\mus]',
    ylabel 'r(t)'
    
    
   case 5
        

    plot(f/1e6,abs(fftshift(R)),'k','LineWidth',lw),legend off
    axis tight, grid on, xlabel 'Frequency [Mhz]',
    ylabel '|R(f)|'
    
       
   case 6
       
       if (mismatched_bool)       

        plot(t/1e-6,r_mis,'k','LineWidth',lw), legend off
        axis tight, grid on, xlabel 'Time [\mus]',  
        ylabel 'rmis(t)'
        
          
       else 

        plot(t/1e-6,abs(r_detected),'k','LineWidth',lw), legend off;
        axis tight, grid on, xlabel 'Time [\mus]', ylabel 'r_d_e_t_e_c_t_e_d(t)'           
        
       end 
       
   case 7
       
       if (mismatched_bool) 
           
        plot(f/1e6,abs(Hmis),'k'),
        axis([(f0-Af)/1e6 (f0+2*Af)/1e6 0 max(abs(Hmis))]), grid on, xlabel 'Frequency [Mhz]',
        ylabel '|Hmis(f)|', legend off
        

       else 

        plot(f/1e6,abs(fftshift(R_DETECTED)),'k','LineWidth',lw),
        axis tight, grid on, xlabel 'Frequency [Mhz]',
        ylabel '|R_DETECTED(f)|', legend off
        
       end 

       
   case 8
       
       if (mismatched_bool) 

        plot(t/1e-6,abs(r_detected),'k','LineWidth',lw), legend off;
        axis tight, grid on, xlabel 'Time [\mus]', ylabel 'r_d_e_t_e_c_t_e_d(t)'
        
        
       else
           
        distance=(t(1:fs/prf)-tau)*3e8/2;
        plot(distance/1e3,max(r_detected(1:fs/prf))*gates(:,1:fs/prf),'LineWidth',lw),
        hold on;
        plot(distance/1e3,abs(r_detected(1:fs/prf)),'k','LineWidth',lw), 
        legend off
        axis tight, grid on, xlabel 'Distance [Km]', ylabel 'r_d_e_t_e_c_t_e_d(t)'
        
       end 
       


   case 9
       
    if  (mismatched_bool)          
        plot(f/1e6,abs(fftshift(R_DETECTED)),'k','LineWidth',lw),
        axis tight, grid on, xlabel 'Frequency [Mhz]',
        ylabel '|R_DETECTED(f)|', legend off
        
    else       
        distance=(t(1:fs/prf)-tau)*3e8/2;
        plot(distance/1e3,max(r_detected(1:fs/prf))*gates(:,1:fs/prf),'LineWidth',lw),
        hold on;
        plot(distance/1e3,abs(r_detected(1:fs/prf)),'k','LineWidth',lw), 
        legend off
        axis tight, grid on, xlabel 'Distance [Km]', ylabel 'r_d_e_t_e_c_t_e_d(t)'
        
    end

   case 10
        distance=(t(1:fs/prf)-tau)*3e8/2;
        plot(distance/1e3,max(r_detected(1:fs/prf))*gates(:,1:fs/prf),'LineWidth',lw),
        hold on;
        plot(distance/1e3,abs(r_detected(1:fs/prf)),'k','LineWidth',lw), 
        legend off
        axis tight, grid on, xlabel 'Distance [Km]', ylabel 'r_d_e_t_e_c_t_e_d(t)'    
        
    otherwise
    plot(t/1e6,s2,'k','LineWidth',lw),
    hold on;
    plot(t/1e6,s3,'b--','LineWidth',lw),
    axis tight, grid on, xlabel 'Time (\mus)', ylabel 's(t)'  
    legend ('s_t(t)', 's_r(t)')
end
set(gcf,'InvertHardcopy','on');
set(gcf,'PaperUnits', 'inches');
papersize = get(gcf, 'PaperSize');
left = (papersize(1)- width)/2;
bottom = (papersize(2)- height)/2;
myfiguresize = [left, bottom, width, height];
set(gcf,'PaperPosition', myfiguresize);
print(h,'-djpeg',name);
close(h)
